| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Protected Member Functions | List of all members
IErrorTool Class Referenceabstract

`#include <GaudiTools/IErrorTool.h>`

Inheritance diagram for IErrorTool:
[legend]
Collaboration diagram for IErrorTool:
[legend]

## Public Member Functions
| DeclareInterfaceID (IErrorTool, 2, 0)
| InterfaceID. More...
virtual StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const =0
| Print the error message, return status code and perform the statistics of error messages. More...
virtual StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const =0
| Print the warning message, return status code and perform the statistics of warning messages. More...
virtual StatusCode | Print (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const MSG::Level lev=MSG::INFO) const =0
| Print the message and return status code. More...
virtual void | Assert (const bool ok, const std::string &message="", const StatusCode sc=StatusCode::FAILURE) const =0
| Assertion - throw exception, if condition is not fulfilled. More...
virtual void | Exception (const std::string &msg, const GaudiException &exc, const StatusCode sc=StatusCode::FAILURE) const =0
| Create and (re)-throw the exception. More...
virtual void | Exception (const std::string &msg, const std::exception &exc, const StatusCode sc=StatusCode::FAILURE) const =0
| Create and (re)-throw the exception. More...
virtual void | Exception (const std::string &msg="no message", const StatusCode sc=StatusCode::FAILURE) const =0
| Create and throw the exception. More...
Public Member Functions inherited from IAlgTool
| DeclareInterfaceID (IAlgTool, 4, 0)
| InterfaceID. More...
virtual const std::string & | type () const =0
| The type of an AlgTool, meaning the concrete AlgTool class. More...
virtual const IInterface * | parent () const =0
| The parent of the concrete AlgTool. More...
virtual StatusCode | configure ()=0
| Configuration (from OFFLINE to CONFIGURED). More...
virtual StatusCode | initialize ()=0
| Initialization (from CONFIGURED to INITIALIZED). More...
virtual StatusCode | start ()=0
| Start (from INITIALIZED to RUNNING). More...
virtual StatusCode | stop ()=0
| Stop (from RUNNING to INITIALIZED). More...
virtual StatusCode | finalize ()=0
| Finalize (from INITIALIZED to CONFIGURED). More...
virtual StatusCode | terminate ()=0
| Initialization (from CONFIGURED to OFFLINE). More...
virtual StatusCode | reinitialize ()=0
| Initialization (from INITIALIZED or RUNNING to INITIALIZED, via CONFIGURED). More...
virtual StatusCode | restart ()=0
| Initialization (from RUNNING to RUNNING, via INITIALIZED). More...
virtual Gaudi::StateMachine::State | FSMState () const =0
| Get the current state. More...
virtual StatusCode | sysInitialize ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysStart ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysStop ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysFinalize ()=0
| Finalization of the Tool. More...
virtual StatusCode | sysReinitialize ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysRestart ()=0
| Initialization of the Tool. More...
Public Member Functions inherited from INamedInterface
| DeclareInterfaceID (INamedInterface, 1, 0)
| InterfaceID. More...
virtual const std::string & | name () const =0
| Retrieve the name of the instance. More...
Public Member Functions inherited from IInterface
virtual void * | i_cast (const InterfaceID &) const =0
| main cast function More...
virtual std::vector< std::string > | getInterfaceNames () const =0
| Returns a vector of strings containing the names of all the implemented interfaces. More...
virtual unsigned long | addRef ()=0
| Increment the reference count of Interface instance. More...
virtual unsigned long | release ()=0
| Release Interface instance. More...
virtual unsigned long | refCount () const =0
| Current reference count. More...
virtual StatusCode | queryInterface (const InterfaceID &ti, void **pp)=0
| Set the void** to the pointer to the requested interface of the instance. More...
virtual | ~IInterface ()=default
| Virtual destructor. More...

## Protected Member Functions
virtual | ~IErrorTool ()=default

## Additional Inherited Members
Public Types inherited from IInterface
enum | Status : StatusCode::code_t { Status::FAILURE = 0, Status::SUCCESS = 1, Status::NO_INTERFACE, Status::VERSMISMATCH, Status::LAST_ERROR }
| Return status. More...
using | iid = Gaudi::InterfaceId< IInterface, 0, 0 >
| Interface ID. More...
using | ext_iids = Gaudi::interface_list< iid >
| Extra interfaces. More...
Static Public Member Functions inherited from IInterface
static const InterfaceID & | interfaceID ()
| Return an instance of InterfaceID identifying the interface. More...

## Detailed Description

Author
  Ivan BELYAEV

Date
  2004-06-28

Definition at line 24 of file IErrorTool.h.

## Constructor & Destructor Documentation

## ◆ ~IErrorTool()

virtual IErrorTool::~IErrorTool | ( |  | ) |
| protected virtual default

## Member Function Documentation

## ◆ Assert()

virtual void IErrorTool::Assert | ( | const bool | ok,
|  | const std::string & | message = `""`,
|  | const StatusCode | sc = `StatusCode::FAILURE`
| ) |  | const
| pure virtual

Assertion - throw exception, if condition is not fulfilled.

See also
  CaloException
  GaudiException

Exceptions

  CaloException | for invalid condition

Parameters

  ok | condition which should be "true"
  message | message to be associated with the exception
  sc | status code to be returned (artificial)

Returns
  status code

Implemented in ErrorTool.

## ◆ DeclareInterfaceID()

IErrorTool::DeclareInterfaceID | ( | IErrorTool | ,
|  | 2 | ,
|  | 0 |
| ) |  |

InterfaceID.

## ◆ Error()

virtual StatusCode IErrorTool::Error | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::FAILURE`,
|  | const size_t | mx = `10`
| ) |  | const
| pure virtual

Print the error message, return status code and perform the statistics of error messages.

IErrorTool* tool = .. ;
if( a < 0 ) { return tool->Error(" 'a' is negative!") ;}
if( b < 0 ) { return tool->Error(" 'b' is illegal!" , StatusCode(25) );
if( c < 0 )
{ return tool->Error(" 'c' is negative" , StatusCode(35) , 50 );

See also
  MsgStream
  IMessageSvc
  StatusCode

Parameters

  msg | error message
  st | status code
  mx | maximal number of printouts

Returns
  status code

Implemented in ErrorTool.

## ◆ Exception() [1/3]

virtual void IErrorTool::Exception | ( | const std::string & | msg,
|  | const GaudiException & | exc,
|  | const StatusCode | sc = `StatusCode::FAILURE`
| ) |  | const
| pure virtual

Create and (re)-throw the exception.

See also
  GaudiException

Exceptions

  CaudiException | always!

Parameters

  msg | exception message
  exc | (previous) exception of type GaudiException
  sc | status code

Returns
  status code (fictive)

Implemented in ErrorTool.

## ◆ Exception() [2/3]

virtual void IErrorTool::Exception | ( | const std::string & | msg,
|  | const std::exception & | exc,
|  | const StatusCode | sc = `StatusCode::FAILURE`
| ) |  | const
| pure virtual

Create and (re)-throw the exception.

See also
  GaudiException

Exceptions

  GaudiException | always!

Parameters

  msg | exception message
  exc | (previous) exception of type std::exception
  sc | status code

Returns
  status code (fictive)

Implemented in ErrorTool.

## ◆ Exception() [3/3]

virtual void IErrorTool::Exception | ( | const std::string & | msg = `"no message"`,
|  | const StatusCode | sc = `StatusCode::FAILURE`
| ) |  | const
| pure virtual

Create and throw the exception.

See also
  GaudiException

Exceptions

  GaudiException | always!

Parameters

  msg | exception message
  sc | status code

Returns
  status code (fictive)

Implemented in ErrorTool.

## ◆ Print()

virtual StatusCode IErrorTool::Print | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::SUCCESS`,
|  | const MSG::Level | lev = `MSG::INFO`
| ) |  | const
| pure virtual

Print the message and return status code.

See also
  MsgStream
  IMessageSvc
  StatusCode

Parameters

  msg | warning message
  st | status code
  lev | print level

Returns
  status code

Implemented in ErrorTool.

## ◆ Warning()

virtual StatusCode IErrorTool::Warning | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::FAILURE`,
|  | const size_t | mx = `10`
| ) |  | const
| pure virtual

Print the warning message, return status code and perform the statistics of warning messages.

See also
  MsgStream
  IMessageSvc
  StatusCode

Parameters

  msg | warning message
  st | statsu code
  mx | maximal number of printouts

Returns
  status code

Implemented in ErrorTool.

The documentation for this class was generated from the following file:

- GaudiAlg/GaudiAlg/IErrorTool.h